(* equality.ml: show differences in how = and == work. *)


open Printf;;

type myrec = {s : string; i : int};;

let _ =
  let a = 5 in                     (* box with 5  *)
  let b = 5 in                     (* box with 5 *)
  let c = a in                     (* box with copy a's contents *)
  printf "---ints---\n";
  printf "a=b  : %b\n" (a=b);      (* a=b  : true *)
  printf "a==b : %b\n" (a==b);     (* a==b : true *)
  printf "a=c  : %b\n" (a=c);      (* a=c  : true *)
  printf "a==c : %b\n" (a==c);     (* a==c : true *)

  let x = ref 5 in                 (* pointer to box w/ 5 *)
  let y = ref 5 in                 (* pointer to new box w/ 5 *)
  let z = x in                     (* copy x's pointer *)
  printf "---int Refs---\n";
  printf "x=y  : %b\n" (x=y);      (* x=y  : true  : same contents *)     
  printf "x==y : %b\n" (x==y);     (* x==y : false : different locations*)
  printf "x=z  : %b\n" (x=z);      (* x=z  : true  : same contents *)     
  printf "x==z : %b\n" (x==z);     (* x==z : true  : same location *)     

  let s = "hi" in                  (* pointer to string of chars *)
  let t = "hi" in                  (* pointer to different string of chars *)
  let u = s in                     (* pointer to same place as s *)
  printf "---Strings---\n";
  printf "s=t  : %b\n" (s=t);      (* s=t  : true  : same contents *)
  printf "s==t : %b\n" (s==t);     (* s==t : false : different locations*)
  printf "s=u  : %b\n" (s=u);      (* s=u  : true  : same contents *)
  printf "s==u : %b\n" (s==u);     (* s==u : true  : same location *)     

  let f = {s="yo"; i=2} in         (* pointer to new record *)
  let g = {s="yo"; i=2} in         (* pointer to new record *)
  let h = f in                     (* pointer to existing record *)
  printf "---Records---\n";
  printf "f=g  : %b\n" (f=g);      (* f=g  : true  : same contents *)     
  printf "f==g : %b\n" (f==g);     (* f==g : false : different locations*)
  printf "f=h  : %b\n" (f=h);      (* f=h  : true  : same contents *)     
  printf "f==h : %b\n" (f==h);     (* f==h : true  : same location *)     
;;

