(* mem_v_memq.ml: demonstrate differences between mem and memq. *)

open Printf;;

let _ =
  let x = "yikes" in
  let y = "boo!"  in
  let z = "gulp"  in

  let listA = [      x;      y;      z] in
  let listB = ["yikes"; "boo!"; "gulp"] in

  let d_yA = List.mem  y listA in   (* deep equals: true *)
  let s_yA = List.memq y listA in   (* shallow equals: true *)
  
  let d_yB = List.mem  y listB in   (* deep equals : true *)
  let s_yB = List.memq y listB in   (* shallow equals: false *)
  
  printf "d_yA : %b\n" d_yA;
  printf "s_yA : %b\n" s_yA;
  printf "d_yB : %b\n" d_yB;
  printf "s_yB : %b\n" s_yB;
  
;;
